// adapted from DIHTML project of delphi inspirion: http://www.yunqa.de/delphi/

//------------------------------------------------------------------------------
// Compiler Version Information
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// Windows
//------------------------------------------------------------------------------

{$IFDEF Win32}
{$IFNDEF MSWINDOWS}
{$DEFINE MSWINDOWS}
{$ENDIF}
{$ENDIF}

//------------------------------------------------------------------------------
// VERXXX to COMPILER_X, DELPHI_X and CPPB_X mappings
//------------------------------------------------------------------------------

{$IFDEF MSWINDOWS}

{$IFDEF VER180}
  {$DEFINE COMPILER_10}
  {$IFDEF BCB}
    {$DEFINE CPPB}
    {$DEFINE CPPB_10}
  {$ELSE}
    {$DEFINE DELPHI}
    {$DEFINE DELPHI_10}
  {$ENDIF}
{$ENDIF}

{$IFDEF VER170}
  {$DEFINE COMPILER_9}
  {$DEFINE DELPHI}
  {$DEFINE DELPHI_9}
{$ENDIF}

{$IFDEF VER150}
  {$DEFINE COMPILER_7}
  {$DEFINE DELPHI}
  {$DEFINE DELPHI_7}
{$ENDIF}

{$IFDEF VER140}
  {$DEFINE COMPILER_6}
  {$IFDEF BCB}
    {$DEFINE CPPB}
    {$DEFINE CPPB_6}
  {$ELSE}
    {$DEFINE DELPHI}
    {$DEFINE DELPHI_6}
  {$ENDIF}
{$ENDIF}

{$IFDEF VER130}
  {$DEFINE COMPILER_5}
  {$IFDEF BCB}
    {$DEFINE CPPB}
    {$DEFINE CPPB_5}
  {$ELSE}
    {$DEFINE DELPHI}
    {$DEFINE DELPHI_5}
  {$ENDIF}
{$ENDIF}

{$IFDEF VER125}
{$DEFINE COMPILER_4}
{$DEFINE CPPB}
{$DEFINE CPPB_4}
{$ENDIF}

{$IFDEF VER120}
{$DEFINE COMPILER_4}
{$DEFINE DELPHI}
{$DEFINE DELPHI_4}
{$ENDIF}

{$IFDEF VER110}
{$DEFINE COMPILER_3}
{$DEFINE CPPB}
{$DEFINE CPPB_3}
{$ENDIF}

{$IFDEF VER100}
{$DEFINE COMPILER_3}
{$DEFINE DELPHI}
{$DEFINE DELPHI_3}
{$ENDIF}

{$IFDEF VER93}
{$DEFINE COMPILER_2} // C++ Builder v1 compiler is really v2
{$DEFINE CPPB}
{$DEFINE CPPB_1}
{$ENDIF}

{$IFDEF VER90}
{$DEFINE COMPILER_2}
{$DEFINE DELPHI}
{$DEFINE DELPHI_2}
{$ENDIF}

{$IFDEF VER80}
{$DEFINE COMPILER_1}
{$DEFINE DELPHI}
{$DEFINE DELPHI_1}
{$ENDIF}

//------------------------------------------------------------------------------
// CPPB_X_UP from CPPB_X mappings
//------------------------------------------------------------------------------

{$IFDEF CPPB_1}
  {$DEFINE CPPB_1_UP}
{$ENDIF}

{$IFDEF CPPB_3}
  {$DEFINE CPPB_1_UP}
  {$DEFINE CPPB_3_UP}
{$ENDIF}

{$IFDEF CPPB_4}
  {$DEFINE CPPB_1_UP}
  {$DEFINE CPPB_3_UP}
  {$DEFINE CPPB_4_UP}
{$ENDIF}

{$IFDEF CPPB_5}
  {$DEFINE CPPB_1_UP}
  {$DEFINE CPPB_3_UP}
  {$DEFINE CPPB_4_UP}
  {$DEFINE CPPB_5_UP}
{$ENDIF}

{$IFDEF CPPB_10}
  {$DEFINE CPPB_1_UP}
  {$DEFINE CPPB_3_UP}
  {$DEFINE CPPB_4_UP}
  {$DEFINE CPPB_5_UP}
  {$DEFINE CPPB_10_UP}
{$ENDIF}

{$IFDEF CPPB_3_UP}
// C++ Builder requires this if you use Delphi components in run-time packages.
{$OBJEXPORTALL ON}
{$ENDIF}

{$ENDIF}

//------------------------------------------------------------------------------
// CLR - DotNet
//------------------------------------------------------------------------------

{$IFDEF CLR}

{$IFDEF VER160}
{$DEFINE COMPILER_8}
{$DEFINE DELPHI}
{$DEFINE DELPHI_8}
{$ENDIF}

{$ENDIF CLR}

//------------------------------------------------------------------------------
// Linux
//------------------------------------------------------------------------------

{$IFDEF LINUX}

{$IFDEF VER150}
{$DEFINE COMPILER_7}
{$DEFINE KYLIX}
{$DEFINE KYLIX_3}
{$ENDIF}

{$IFDEF VER140}
{$DEFINE COMPILER_6}
{$DEFINE KYLIX}
{$DEFINE KYLIX_2}
{$ENDIF}

{$IFDEF KYLIX_2}
{$DEFINE KYLIX_1_UP}
{$DEFINE KYLIX_2_UP}
{$ENDIF}

{$IFDEF KYLIX_3}
{$DEFINE KYLIX_1_UP}
{$DEFINE KYLIX_2_UP}
{$DEFINE KYLIX_3_UP}
{$ENDIF}

{$ENDIF}

//------------------------------------------------------------------------------
// DELPHI_X_UP from DELPHI_X mappings
//------------------------------------------------------------------------------

{$IFDEF DELPHI_1}
{$DEFINE DELPHI_1_UP}
{$DEFINE DELPHI_1_DOWN}
{$DEFINE DELPHI_2_DOWN}
{$DEFINE DELPHI_3_DOWN}
{$DEFINE DELPHI_4_DOWN}
{$DEFINE DELPHI_5_DOWN}
{$DEFINE DELPHI_6_DOWN}
{$DEFINE DELPHI_7_DOWN}
{$DEFINE DELPHI_8_DOWN}
{$DEFINE DELPHI_9_DOWN}
{$DEFINE DELPHI_10_DOWN}
{$ENDIF}

{$IFDEF DELPHI_2}
{$DEFINE DELPHI_1_UP}
{$DEFINE DELPHI_2_UP}
{$DEFINE DELPHI_2_DOWN}
{$DEFINE DELPHI_3_DOWN}
{$DEFINE DELPHI_4_DOWN}
{$DEFINE DELPHI_5_DOWN}
{$DEFINE DELPHI_6_DOWN}
{$DEFINE DELPHI_7_DOWN}
{$DEFINE DELPHI_8_DOWN}
{$DEFINE DELPHI_9_DOWN}
{$DEFINE DELPHI_10_DOWN}
{$ENDIF}

{$IFDEF DELPHI_3}
{$DEFINE DELPHI_1_UP}
{$DEFINE DELPHI_2_UP}
{$DEFINE DELPHI_3_UP}
{$DEFINE DELPHI_3_DOWN}
{$DEFINE DELPHI_4_DOWN}
{$DEFINE DELPHI_5_DOWN}
{$DEFINE DELPHI_6_DOWN}
{$DEFINE DELPHI_7_DOWN}
{$DEFINE DELPHI_8_DOWN}
{$DEFINE DELPHI_9_DOWN}
{$DEFINE DELPHI_10_DOWN}
{$ENDIF}

{$IFDEF DELPHI_4}
{$DEFINE DELPHI_1_UP}
{$DEFINE DELPHI_2_UP}
{$DEFINE DELPHI_3_UP}
{$DEFINE DELPHI_4_UP}
{$DEFINE DELPHI_4_DOWN}
{$DEFINE DELPHI_5_DOWN}
{$DEFINE DELPHI_6_DOWN}
{$DEFINE DELPHI_7_DOWN}
{$DEFINE DELPHI_8_DOWN}
{$DEFINE DELPHI_9_DOWN}
{$DEFINE DELPHI_10_DOWN}
{$ENDIF}

{$IFDEF DELPHI_5}
{$DEFINE DELPHI_1_UP}
{$DEFINE DELPHI_2_UP}
{$DEFINE DELPHI_3_UP}
{$DEFINE DELPHI_4_UP}
{$DEFINE DELPHI_5_UP}
{$DEFINE DELPHI_5_DOWN}
{$DEFINE DELPHI_6_DOWN}
{$DEFINE DELPHI_7_DOWN}
{$DEFINE DELPHI_8_DOWN}
{$DEFINE DELPHI_9_DOWN}
{$DEFINE DELPHI_10_DOWN}
{$ENDIF}

{$IFDEF DELPHI_6}
{$DEFINE DELPHI_1_UP}
{$DEFINE DELPHI_2_UP}
{$DEFINE DELPHI_3_UP}
{$DEFINE DELPHI_4_UP}
{$DEFINE DELPHI_5_UP}
{$DEFINE DELPHI_6_UP}
{$DEFINE DELPHI_6_DOWN}
{$DEFINE DELPHI_7_DOWN}
{$DEFINE DELPHI_8_DOWN}
{$DEFINE DELPHI_9_DOWN}
{$DEFINE DELPHI_10_DOWN}
{$ENDIF}

{$IFDEF DELPHI_7}
{$DEFINE DELPHI_1_UP}
{$DEFINE DELPHI_2_UP}
{$DEFINE DELPHI_3_UP}
{$DEFINE DELPHI_4_UP}
{$DEFINE DELPHI_5_UP}
{$DEFINE DELPHI_6_UP}
{$DEFINE DELPHI_7_UP}
{$DEFINE DELPHI_7_DOWN}
{$DEFINE DELPHI_8_DOWN}
{$DEFINE DELPHI_9_DOWN}
{$DEFINE DELPHI_10_DOWN}
{$ENDIF}

{$IFDEF DELPHI_8}
{$DEFINE DELPHI_1_UP}
{$DEFINE DELPHI_2_UP}
{$DEFINE DELPHI_3_UP}
{$DEFINE DELPHI_4_UP}
{$DEFINE DELPHI_5_UP}
{$DEFINE DELPHI_6_UP}
{$DEFINE DELPHI_7_UP}
{$DEFINE DELPHI_8_UP}
{$DEFINE DELPHI_8_DOWN}
{$DEFINE DELPHI_9_DOWN}
{$DEFINE DELPHI_10_DOWN}
{$ENDIF}

{$IFDEF DELPHI_9}
{$DEFINE DELPHI_1_UP}
{$DEFINE DELPHI_2_UP}
{$DEFINE DELPHI_3_UP}
{$DEFINE DELPHI_4_UP}
{$DEFINE DELPHI_5_UP}
{$DEFINE DELPHI_6_UP}
{$DEFINE DELPHI_7_UP}
{$DEFINE DELPHI_8_UP}
{$DEFINE DELPHI_9_UP}
{$DEFINE DELPHI_9_DOWN}
{$DEFINE DELPHI_10_DOWN}
{$ENDIF}

{$IFDEF DELPHI_10}
  {$DEFINE DELPHI_1_UP}
  {$DEFINE DELPHI_2_UP}
  {$DEFINE DELPHI_3_UP}
  {$DEFINE DELPHI_4_UP}
  {$DEFINE DELPHI_5_UP}
  {$DEFINE DELPHI_6_UP}
  {$DEFINE DELPHI_7_UP}
  {$DEFINE DELPHI_8_UP}
  {$DEFINE DELPHI_9_UP}
  {$DEFINE DELPHI_10_UP}
  {$DEFINE DELPHI_10_DOWN}
{$ENDIF}

//------------------------------------------------------------------------------
// COMPIlER_X_UP from COMPILER_X mappings
//------------------------------------------------------------------------------

{$IFDEF COMPILER_1}
{$DEFINE COMPILER_1_UP}
{$ENDIF}

{$IFDEF COMPILER_2}
{$DEFINE COMPILER_1_UP}
{$DEFINE COMPILER_2_UP}
{$ENDIF}

{$IFDEF COMPILER_3}
{$DEFINE COMPILER_1_UP}
{$DEFINE COMPILER_2_UP}
{$DEFINE COMPILER_3_UP}
{$ENDIF}

{$IFDEF COMPILER_4}
{$DEFINE COMPILER_1_UP}
{$DEFINE COMPILER_2_UP}
{$DEFINE COMPILER_3_UP}
{$DEFINE COMPILER_4_UP}
{$ENDIF}

{$IFDEF COMPILER_5}
{$DEFINE COMPILER_1_UP}
{$DEFINE COMPILER_2_UP}
{$DEFINE COMPILER_3_UP}
{$DEFINE COMPILER_4_UP}
{$DEFINE COMPILER_5_UP}
{$ENDIF}

{$IFDEF COMPILER_6}
{$DEFINE COMPILER_1_UP}
{$DEFINE COMPILER_2_UP}
{$DEFINE COMPILER_3_UP}
{$DEFINE COMPILER_4_UP}
{$DEFINE COMPILER_5_UP}
{$DEFINE COMPILER_6_UP}
{$ENDIF}

{$IFDEF COMPILER_7}
{$DEFINE COMPILER_1_UP}
{$DEFINE COMPILER_2_UP}
{$DEFINE COMPILER_3_UP}
{$DEFINE COMPILER_4_UP}
{$DEFINE COMPILER_5_UP}
{$DEFINE COMPILER_6_UP}
{$DEFINE COMPILER_7_UP}
{$ENDIF}

{$IFDEF COMPILER_8}
{$DEFINE COMPILER_1_UP}
{$DEFINE COMPILER_2_UP}
{$DEFINE COMPILER_3_UP}
{$DEFINE COMPILER_4_UP}
{$DEFINE COMPILER_5_UP}
{$DEFINE COMPILER_6_UP}
{$DEFINE COMPILER_7_UP}
{$DEFINE COMPILER_8_UP}
{$ENDIF}

{$IFDEF COMPILER_9}
{$DEFINE COMPILER_1_UP}
{$DEFINE COMPILER_2_UP}
{$DEFINE COMPILER_3_UP}
{$DEFINE COMPILER_4_UP}
{$DEFINE COMPILER_5_UP}
{$DEFINE COMPILER_6_UP}
{$DEFINE COMPILER_7_UP}
{$DEFINE COMPILER_8_UP}
{$DEFINE COMPILER_9_UP}
{$ENDIF}

{$IFDEF COMPILER_10}
  {$DEFINE COMPILER_1_UP}
  {$DEFINE COMPILER_2_UP}
  {$DEFINE COMPILER_3_UP}
  {$DEFINE COMPILER_4_UP}
  {$DEFINE COMPILER_5_UP}
  {$DEFINE COMPILER_6_UP}
  {$DEFINE COMPILER_7_UP}
  {$DEFINE COMPILER_8_UP}
  {$DEFINE COMPILER_9_UP}
  {$DEFINE COMPILER_10_UP}
{$ENDIF}
